<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

////////////////////////////////////////
// Validation de la requête : matière //
////////////////////////////////////////

// Recherche de la matière concernée, variable $matiere
// Si $_REQUEST['cle'] existe, on la cherche dans les matières disponibles.
$mysqli = connectsql();
$resultat = $mysqli->query('SELECT id, cle, nom, colles_protection AS protection FROM matieres WHERE colles'.( ( $autorisation == 4 ) ? " OR  FIND_IN_SET(id,'${_SESSION['matieres']}')" : '' ));
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
  }
  $resultat->free();
  // Si aucune matière trouvée
  if ( !isset($matiere) )  {
    debut($mysqli,'Programme de colles','Mauvais paramètre d\'accès à cette page.',$autorisation,' ');
    $mysqli->close();
    fin();
  }
}
// Si aucune matière présentant son programme de colle n'est enregistrée
else  {
  debut($mysqli,'Programme de colles','Cette page ne contient aucune information.',$autorisation,' ');
  $mysqli->close();
  fin();
}


/////////////////////////////
// Vérification de l'accès //
/////////////////////////////
// Interdiction de voir les programmes de protection élevée ou non associés à
// ses propres matières si on est invité/élève/colleur
// Toutes les matières sont visibles pour les professeurs (édition: cf plus bas)
if ( $matiere['protection'] && ( $autorisation > 0 ) && ( $autorisation < 4 )
  && ( ( $matiere['protection'] > $autorisation ) || ( !in_array($matiere['id'],explode(',',$_SESSION['matieres'])) ) ) )  {
  debut($mysqli,"Programme de colles - ${matiere['nom']}",'Vous n\'avez pas accès à cette page.',$autorisation,"colles?${matiere['cle']}");
  $mysqli->close();
  fin();
}
// Connexion nécessaire si protection
if ( $matiere['protection'] && !$autorisation )  {
  $titre = "Programme de colles - ${matiere['nom']}";
  $actuel = "colles?${matiere['cle']}";
  include('login.php');
}
// Mode édition pour les professeurs sur leurs propres matières uniquement
$edition = ( ( $autorisation == 4 ) && in_array($matiere['id'],explode(',',$_SESSION['matieres'])) );

//////////////////////////////////////////////////////////////////
// Validation de la requête : semaine(s) ou éléments à afficher //
//////////////////////////////////////////////////////////////////

// Récupération des semaines et du nombre de semaines
$resultat = $mysqli->query("SELECT id, DATE_FORMAT(debut,'%w%Y%m%e') AS debut, DATE_FORMAT(debut,'%y%v') AS semaine, vacances FROM semaines");
$select_semaines = "\n      <option value=\"0\">Toute l'année</option>";
$semaines = array(0=>'');
while ( $r = $resultat->fetch_assoc() )  {
  $semaines[] = $r['semaine'];
  switch ( $r['vacances'] )  {
    case 0:
      $select_semaines .= "\n      <option value=\"${r['id']}\">".format_date($r['debut']).'</option>';
      break;
    case 1:
      $select_semaines .= "\n      <option value=\"${r['id']}\">Vacances de Toussaint</option>";
      break;
    case 2:
      $select_semaines .= "\n      <option value=\"${r['id']}\">Vacances de Noël</option>";
      break;
    case 3:
      $select_semaines .= "\n      <option value=\"${r['id']}\">Vacances d'hiver</option>";
      break;
    case 4:
      $select_semaines .= "\n      <option value=\"${r['id']}\">Vacances de Pâques</option>";
  }
}
$resultat->free();
$nmax = count($semaines);

// Recherche sur du texte
$recherche = '';
if ( isset($_REQUEST['recherche']) && strlen($_REQUEST['recherche']) )  {
  $recherche = htmlspecialchars($_REQUEST['recherche']);
  $n = 0;
  $nb = $nmax;
}
// Vue de tout le programme de l'année
elseif (  isset($_REQUEST['tout']) )  {
  $requete = '';
  $n = 0;
  $nb = $nmax;
}
// Vue d'une (ou plusieurs) semaine précise
elseif ( isset($_REQUEST['n']) && ctype_digit($n = $_REQUEST['n']) && ( $n > 0 ) && ( $n <= $nmax ) )  {
  $requete = "WHERE s.id >= $n";
  // Nombre d'éléments vus par défaut : 2 en mode édition, 1 sinon
  if ( !isset($_REQUEST['nb']) || !ctype_digit($nb = $_REQUEST['nb']) || ( $nb < 1 ) )
    $nb = 1+$edition;
}
// Vue de la semaine en cours, prochaine semaine à partir du vendredi 19h
// $n est false si non trouvé (hors année scolaire)
else  {
  if ( ( ( $n = array_search(date('yW', strtotime('Monday this week',time()+104400)),$semaines) ) !== false ) )  {
    $requete = "WHERE s.id >= $n";
    $nb = 1+$edition;
  }
}

////////////
/// HTML ///
////////////
debut($mysqli,"Programme de colles - ${matiere['nom']}". ( ( $edition && $matiere['protection'] ) ? "<span class=\"icon-lock${matiere['protection']}\"></span>" : '' ),$message,$autorisation,"colles?${matiere['cle']}",$matiere['id']);

// MathJax désactivé par défaut
$mathjax = false;

// Formulaire de la demande des semaines à afficher
$select_semaines = str_replace("\"$n\"","\"$n\" selected",$select_semaines);
$boutons = "
  <p id=\"recherchecolle\" class=\"topbarre\">
    <a class=\"icon-precedent\" href=\"?${matiere['cle']}&amp;n=".max(1,$n-1)."\" title=\"Semaine précédente\"></a>
    <a class=\"icon-suivant\" href=\"?${matiere['cle']}&amp;n=".min($n+1,$nmax)."\" title=\"Semaine suivante\"></a>
    <a class=\"icon-voirtout\" href=\"?${matiere['cle']}&amp;tout\" title=\"Voir l'ensemble du programme de colles\"></a>
    <select id=\"semaines\" onchange=\"window.location='?${matiere['cle']}&amp;'+((this.value>0)?'n='+this.value:'tout');\">$select_semaines
    </select>
    <input type=\"text\" value=\"$recherche\" onchange=\"window.location='?${matiere['cle']}&amp;recherche='+this.value;\" title=\"Recherche dans les textes des programmes de colles\">
    <span class=\"icon-recherche\" onclick=\"if( $(this).prev().is(':visible') && $(this).prev().val().length ) window.location='?${matiere['cle']}&amp;recherche='+$(this).prev().val(); else $(this).prev().show();\"></span>
  </p>
";

// Affichage du titre de chaque semaine
function generetitre($date,$vacances)  {
  switch ( $vacances )  {
    case 0:
      return'Semaine du '.format_date($date);
    case 1:
      return ucfirst(format_date($date))."&nbsp;: Vacances de Toussaint";
    case 2:
      return ucfirst(format_date($date))."&nbsp;: Vacances de Noël";
    case 3:
      return ucfirst(format_date($date))."&nbsp;: Vacances d'hiver";
    case 4:
      return ucfirst(format_date($date))."&nbsp;: Vacances de Pâques";
  }
}

// Affichage public sans édition
if ( !$edition )  {
  echo $boutons;
  if ( $n !== false )  {
    // Affichage des programmes de colles diffusés
    if ( strlen($recherche) )
      $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS debut, s.colle, s.vacances, c.texte
                                  FROM colles AS c LEFT JOIN semaines AS s ON c.semaine=s.id
                                  WHERE c.matiere = ${matiere['id']} AND c.cache = 0 AND c.texte LIKE '%".$mysqli->real_escape_string($_REQUEST['recherche']).'%\' ORDER BY c.semaine');
    else
      $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS debut, s.colle, s.vacances, c.texte
                                  FROM semaines AS s
                                  LEFT JOIN (SELECT texte, semaine FROM colles WHERE matiere = ${matiere['id']} AND cache = 0) AS c ON c.semaine=s.id
                                  $requete" );
    if ( $resultat->num_rows )  {
      $compteur = 0;
      while ( ( $compteur < $nb ) && ( $r = $resultat->fetch_assoc() ) )  {
        $mathjax = ( $mathjax ) ? true : strpos($r['texte'],'$')+strpos($r['texte'],'\\');
        $titre = generetitre($r['debut'],$r['vacances']);
        if ( $r['colle'] )  {
          $compteur = $compteur+1;
          $texte = ( is_null($r['texte']) ) ? '    <p>Le programme de colles de cette semaine n\'est pas défini.</p>' : $r['texte'];
        }
        else
          $texte = ( $r['vacances'] ) ? '' : '    <p>Il n\'y a pas de colles cette semaine.</p>';
        echo <<<FIN
      
  <article>
    <h3>$titre</h3>
$texte
  </article>

FIN;
      }
      $resultat->free();
    }
    else
      echo "\n  <h2>Aucun résultat n'a été trouvé pour cette recherche.</h2>\n";
  }
  else
    echo "\n  <h2>L'année est terminée... Bonnes vacances&nbsp;!</h2>\n  <p><a href=\"?${matiere['cle']}&amp;tout\">Revoir tout le programme de l'année</a></p>\n";
}

// Affichage professeur éditeur
else  {
  echo <<<FIN
  
  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des programmes de colles"></a>
$boutons
FIN;
  if ( $n !== false )  {
    // Affichage des semaines concernées
    // Le programme est identifié par le couple semaine-matière plutôt que son
    // identifiant propre pour assurer une cohérence entre les programmes entrés
    // et ceux non entrés/supprimés.
    if ( strlen($recherche) )
      $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS debut, s.colle, s.vacances, c.texte, s.id, c.cache 
                                  FROM colles AS c LEFT JOIN semaines AS s ON c.semaine=s.id
                                  WHERE c.matiere = ${matiere['id']} AND c.texte LIKE '%$recherche%' ORDER BY c.semaine");
    else
      $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS debut, s.colle, s.vacances, c.texte, s.id, c.cache 
                                  FROM semaines AS s
                                  LEFT JOIN (SELECT texte, semaine, cache FROM colles WHERE matiere = ${matiere['id']}) AS c ON c.semaine=s.id
                                  $requete");
    if ( $resultat->num_rows )  {
      $compteur = 0;
      while ( ( $compteur < $nb ) && ( $r = $resultat->fetch_assoc() ) )  {
        $mathjax = ( $mathjax ) ? true : strpos($r['texte'],'$')+strpos($r['texte'],'\\');
        $titre = generetitre($r['debut'],$r['vacances']);
        if ( $r['colle'] )  {
          $compteur = $compteur+1;
          if ( is_null($r['texte']) )
            echo <<<FIN

  <article id="${r['id']}-${matiere['id']}" data-id="colles|${r['id']}-${matiere['id']}">
    <h3 class="edition">$titre</h3>
    <a class="icon-aide" data-id="colle" title="Aide pour l'édition de ce programme de colles"></a>
    <a class="icon-montre" style="display:none;" title="Afficher le programme de colles sur la partie publique"></a>
    <a class="icon-cache" style="display:none;" title="Rendre invisible le programme de colles sur la partie publique"></a>
    <a class="icon-supprime" style="display:none;" title="Supprimer ce programme de colles"></a>
    <a class="icon-ajoute" data-id="ajoute" data-remplace="${r['id']}-${matiere['id']}" title="Entrer ce programme de colles"></a>
    <div class="editable-remplace edithtml" data-id="colles|texte|${r['id']}-${matiere['id']}" data-placeholder="Texte du programme de colles">
      <p>Le programme de colles de cette semaine n'est pas encore défini.</p>
    </div>
  </article>

FIN;
          else  {
            if ( $r['cache'] )  {
              $classe_cache = ' class="cache"';
              $visible = '<a class="icon-montre" title="Afficher le programme de colles sur la partie publique"></a>
    <a class="icon-cache" style="display:none;" title="Rendre invisible le programme de colles sur la partie publique"></a>';
            }
            else  {
              $classe_cache = '';
              $visible = '<a class="icon-montre" style="display:none;" title="Afficher le programme de colles sur la partie publique"></a>
    <a class="icon-cache" title="Rendre invisible le programme de colles sur la partie publique"></a>';
            }
            echo <<<FIN

  <article$classe_cache data-id="colles|${r['id']}-${matiere['id']}">
    <h3 class="edition">$titre</h3>
    <a class="icon-aide" data-id="colle" title="Aide pour l'édition de ce programme de colles"></a>
    $visible
    <a class="icon-supprime" title="Supprimer ce programme de colles"></a>
    <a class="icon-ajoute" style="display:none;" data-id="ajoute" data-remplace="${r['id']}-${matiere['id']}" title="Entrer ce programme de colles"></a>
    <div class="editable edithtml mat${matiere['id']}" data-id="colles|texte|${r['id']}-${matiere['id']}" data-placeholder="Texte du programme de colles">
${r['texte']}
    </div>
  </article>

FIN;
          }
        }
        else  {
          $texte = ( $r['vacances'] ) ? '' : '      <p>Il n\'y a normalement pas de colles cette semaine-là.</p><p>S\'il s\'agit d\'une erreur, cela est modifiable <a href="semaines">sur la page des semaines</a></p>';
          echo <<<FIN

  <article>
    <h3>$titre</h3>
$texte
  </article>

FIN;
        }
      }
      $resultat->free();
    }
    else
      echo "\n  <article><h2>Aucun résultat n'a été trouvé pour cette recherche.</h2></article>\n";
  }
  else
    echo "\n  <article><h2>L'année est terminée.</h2>\n  <p><a href=\"?${matiere['cle']}&amp;tout\">Revoir tout le programme de l'année</a></p></article>\n";

  // Aide et formulaire d'ajout
?>

  <form id="form-ajoute">
    <textarea name="texte" class="edithtml" rows="10" cols="100" data-placeholder="Texte du programme de colles (obligatoire)"></textarea>
    <p class="ligne"><label for="cache">Ne pas diffuser sur la partie publique&nbsp;: </label><input type="checkbox" id="cache" name="cache" value="1"></p>
    <input type="hidden" name="id" value="">
    <input type="hidden" name="table" value="colles">
  </form>
  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici d'ajouter et de modifier des programmes de colles. On peut précédemment sélectionner une semaine ou effectuer une recherche de texte.</p>
    <p>Chaque programme de colles est associé à une semaine du planning annuel. Il est impossible de déplacer un programme de colles.</p>
    <p>Si une semaine de colles ne contient pas de programme, il est possible d'en rajouter un en cliquant sur le bouton <span class="icon-ajoute"></span>.</p>
    <p>Les textes modifiables sont dans les zones indiquées par des pointillés. Ils sont modifiables en cliquant sur les boutons <span class="icon-edite"></span> et en validant avec le bouton <span class="icon-ok"></span> qui apparaît alors.</p>
    <h4>Autres réglages</h4>
    <p>Vous ne pouvez modifier les programmes de colles et leur possibilité d'accès que pour les matières qui sont associées à votre compte. Tout cela est modifiable dans la page de gestion des <a href="matieres">Matières</a>.</p>
    <p>Vous pouvez modifier les semaines avec ou sans colle et les vacances scolaires sur la page du <a href="planning">Planning annuel</a>.</p>
  </div>

  <div id="aide-colle">
    <h3>Aide et explications</h3>
    <p>Le texte de chaque programme de colle existant est modifiable, en cliquant sur le bouton <span class="icon-edite"></span>. Si aucun programme de colle n'existe pour la semaine concerné, il est possible d'en créer un en cliquant sur le bouton <span class="icon-ajoute"></span>. Chaque contenu éditable est indiqué par une bordure en pointillés.</p>
    <p>Une fois le texte édité, il est validé en appuyant sur le bouton <span class="icon-ok"></span>. Au contraire, un clic sur le bouton <span class="icon-annule"></span> annule l'édition.</p>
    <p>Si la connexion est inactive depuis longtemps, une identification sera à nouveau nécessaire.</p>
    <p>D'autres modifications sont possibles à l'aide des boutons disponibles pour chaque programme de colles&nbsp;:</p>
    <ul>
      <li><span class="icon-supprime"></span>&nbsp;: supprimer le programme de colles (une confirmation sera demandée)</li>
      <li><span class="icon-cache"></span>&nbsp;: rendre le programme de colles non visible sur la partie publique. Cela peut être utile pour entrer ses programmes de colles à l'avance ou si l'on se rend compte d'une grosse erreur que l'on souhaite corriger à l'abri des regards (le programme est toujours modifiable).</li>
      <li><span class="icon-montre"></span>&nbsp;: afficher le programme de colles sur la partie publique</li>
    </ul>
    <p>Le texte doit être formaté en HTML&nbsp;: par exemple, chaque bloc de texte doit être encadré par &lt;p&gt; et &lt;/p&gt;. Il peut donc contenir des liens vers les autres pages du site, vers des documents du site, vers le web... Des boutons sont fournis pour aider au formatage (ainsi qu'une aide).</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de créer un nouveau programme de colles. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-annule"></span>.</p>
    <p>Le texte doit être formaté en HTML&nbsp;: par exemple, chaque bloc de texte doit être encadré par &lt;p&gt; et &lt;/p&gt;. Il peut donc contenir des liens vers les autres pages du site, vers des documents du site, vers le web... Des boutons sont fournis pour aider au formatage (ainsi qu'une aide).</p>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement ce programme de colles, par exemple pour le diffuser ultérieurement.</p>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement ce programme de colles, par exemple pour le diffuser ultérieurement. Si la case est cochée, le programme de colles ne sera pas diffusé et pourra être affiché à l'aide du bouton <span class="icon-montre"></span>. Si la case est décochée, le programme de colles sera immédiatement visible et pourra être rendu invisible à l'aide du bouton <span class="icon-cache"></span>.</p>
  </div>
  
  <p id="log"></p>
<?php
}

$mysqli->close();
fin($edition,$mathjax);
?>
